// toppane.cpp
// Copyright (C) 2007-2009 Andrew Munkres
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA


#include <klocale.h>
#include <kdebug.h>
#include <QHeaderView>
#include "toppane.h"

#include "koeurlconfig.h" // Autogenerated by kconfig_compiler

#include "toppane.moc" // This must be here for moc to be run.

TopPane::TopPane(QSplitter *parent): MyTreeWidget(parent), m_shown(true)
{
  setRootIsDecorated(true);
  header()->setResizeMode(QHeaderView::Interactive);
  header()->setClickable(true);
  header()->setSortIndicatorShown(true);
  header()->setVisible(true);
  connect(header(), SIGNAL(sectionClicked(int)), this, SLOT(performSort(int)));
  
  connect(this, SIGNAL(selectionChanged(QTreeWidgetItem *)),
          parent->parent()->parent(), SLOT(selectMessage(QTreeWidgetItem *)));
}

void TopPane::toggleShown(bool)
{
  if (m_shown)
  {
    m_shown = false;
    hide();
  }
  else
  {
    m_shown = true;
    show();
  }
}

void TopPane::performSort(int column)
{
  sortItems((-1 == column) ? header()->sortIndicatorSection() : column,
            header()->sortIndicatorOrder());
}
